* Version 2.1
LPARAMETERS lcFileName,cCur,lcFFields,lnStartRows,lnTable,lcTrue
* Parameters
* lcFileName		name of the docx
* cCur				name of the table / cursor ; optional ; default ALIAS()
* lcFFields			list of fields to be outputted ; optional ; default all fields
* lnStartRows		starting row (the first lnStartRows - 1 rows are skipped) ; optional ; default 1 (all rows)
* lnTable			table# ; optional ; default 1
* lcTrue			the text representing "true" for boolean fields
DECLARE Sleep IN WIN32API INTEGER 
#DEFINE ERRLANG "En"
#IF ERRLANG = "Ro"
	#DEFINE ERRMESS0 "Eroare"
	#DEFINE ERRMESS1 "Nimic de importat"
	#DEFINE ERRMESS2 "Deschideti, va rog, tabelul / cursorul"
	#DEFINE ERRMESS3 "Tabel  inexistent"
	#DEFINE ERRMESS4 "Eroare la deschiderea"
#ELIF ERRLANG = "Fr"
	#DEFINE ERRMESS0 "Erreur"
	#DEFINE ERRMESS1 "Rien a ajouter"
	#DEFINE ERRMESS2 "S'il vous plat ouvrir la table / curseur"
	#DEFINE ERRMESS3 "Table introuvable"
	#DEFINE ERRMESS4 "Erreur d'ouverture"
#ELIF ERRLANG = "Nl" && Koen Piller
	#DEFINE ERRMESS0 "Fout"
	#DEFINE ERRMESS1 "Niets te importeren"
	#DEFINE ERRMESS2 "Doe alsjeblieft table / cursor"
	#DEFINE ERRMESS3 "Tabel nietb gevonden"
	#DEFINE ERRMESS4 "Fout bij openen"
#ELSE
	#DEFINE ERRMESS0 "Error"
	#DEFINE ERRMESS1 "Nothing to append"
	#DEFINE ERRMESS2 "Please open table / cursor"
	#DEFINE ERRMESS3 "Table not found"
	#DEFINE ERRMESS4 "Error opening"
#ENDIF

LOCAL lcDir,lSetTalk,lnFFields,laFFields[1],lnColsNoAll,laFieldsAll[1],lnColsNo,laFields[1],lnCurCol,llMemos,lnSelect
lnSelect = SELECT(0)

IF PCOUNT() < 1 
	MESSAGEBOX(ERRMESS1,16,ERRMESS0)
	RETURN
ELSE
	IF VARTYPE(m.lcFileName) $ "CV"
		lcFileName = FORCEEXT(m.lcFileName,"docx")
		IF !FILE(m.lcFileName)
			MESSAGEBOX(ERRMESS1,16,ERRMESS0)
			RETURN
		ENDIF
	ELSE
		MESSAGEBOX(ERRMESS1,16,ERRMESS0)
		RETURN
	ENDIF
ENDIF
IF PCOUNT() >= 2 
	IF VARTYPE(m.cCur) $ "CV"
		IF USED(m.cCur)
			SELECT (m.cCur)
		ELSE
			MESSAGEBOX(ERRMESS2,16,ERRMESS0)
			RETURN
		ENDIF
	ELSE
		cCur = ALIAS()
	ENDIF
ELSE
	cCur = ALIAS()
ENDIF
IF PCOUNT()<3
	lcFFields = ""
ELSE
	IF VARTYPE(m.lcFFields) <> "C"
		lcFFields = ""
	ELSE
		lnFFields = ALINES(laFFields,m.lcFFields,1+4,",")
	ENDIF
ENDIF
IF PCOUNT() < 4
	lnStartRows = 1
ELSE
	IF VARTYPE(m.lnStartRows) <> "N"
		lnStartRows = 1
	ENDIF
ENDIF
IF PCOUNT()<5
	lnTable = 1
ELSE
	IF VARTYPE(m.lnTable) <> "N"
		lnTable = 1
	ENDIF
ENDIF
IF PCOUNT()<6
	lcTrue = "true"
ELSE
	IF VARTYPE(m.lcTrue) <> "C"
		lcTrue = "true"
	ELSE
		lcTrue = LOWER(m.lcTrue)
	ENDIF
ENDIF

lSetTalk = SET("Talk")
SET TALK OFF 
lnColsNoAll = AFIELDS(m.laFieldsAll,m.cCur)
STORE .F. TO llMemos
lnColsNo = 0
FOR lnCurCol = 1 TO m.lnColsNoAll
	IF m.laFieldsAll[m.lnCurCol,2] $ "NFYBIDTLCVM"
		IF !EMPTY(m.lcFFields)
			IF ASCAN(m.laFFields,laFieldsAll[m.lnCurCol,1],1,-1,-1,1+2+4)=0
				LOOP
			ENDIF
		ENDIF
		lnColsNo = m.lnColsNo + 1
		DIMENSION laFields[m.lnColsNo,3]
		laFields[m.lnColsNo,1] = laFieldsAll[m.lnCurCol,1]
		laFields[m.lnColsNo,2] = laFieldsAll[m.lnCurCol,2]
		laFields[m.lnColsNo,3] = m.lnCurCol
		IF laFields[m.lnColsNo,2] == "M"
			llMemos = .T.
		ENDIF
	ELSE
		LOOP
	ENDIF
NEXT

lcDir = extract(m.lcFileName)

= get_cells(ADDBS(m.lcDir) + "document.xml",m.cCur,@laFields,m.lnStartRows,m.lnTable,m.lcTrue)
cleanup(m.lcDir)
SET TALK &lSetTalk
SELECT (m.lnSelect)
RETURN .T.

*********************
* Extract xml files *
*********************
FUNCTION extract
	LPARAMETERS lcFileName
	LOCAL lcDir,lcZip,oShell,ofile,loErr as Exception,lcSetSaf,lni,lnFF
	lcDir = ADDBS(SYS(2023)) + SYS(2015)
	lcZip = FORCEEXT(m.lcDir,'.zip')
	COPY FILE (m.lcFileName) TO (m.lcZip)
	MD (m.lcDir)
	oShell = CREATEOBJECT("shell.application")
	TRY
		FOR lni = 0 TO m.oShell.NameSpace(ADDBS(m.lcZip)+'word').items.count - 1
			ofile = m.oShell.NameSpace(ADDBS(m.lcZip)+'word').items.item(m.lni)
			IF m.ofile.name == 'document.xml'
				oShell.NameSpace( m.lcDir).copyhere( m.ofile)
				lnFF = FOPEN(ADDBS(lcDir) + m.ofile.name)
				DO WHILE m.lnFF < 0
					sleep(50)
					lnFF = FOPEN(m.ofile.name)
				ENDDO
				FCLOSE(m.lnFF)
			ENDIF
		ENDFOR
	CATCH TO loErr
	ENDTRY
RETURN lcDir
	

*****************
* Read document *
*****************
FUNCTION get_cells
	LPARAMETERS lcStr,cCur,laField,lnStartRows,lnTable,lcTrue
	LOCAL lcSetDec,lnCurRow,lnField,laFieldGat[1],lni,lcWholeDoc,lnNoOfTables,lcWholeTable,lcWholeRow,lcCell,lcVal,lcTable,lcTextPiece,lnPar,lcPar,lcWholeWal
	LOCAL llNumber,llDate,llTime,llBool,lnSpan,lcSpan,lnFieldExtr,lnj
	lnField = ALEN(laField,1)
	lcSetDec = SET("Decimals")
	SET DECIMALS TO 10

	lcWholeDoc = FILETOSTR(m.lcStr)
	lnNoOfTables = OCCURS("<w:tbl>",m.lcWholeDoc)
	IF m.lnNoOfTables < m.lnTable
		MESSAGEBOX(ERRMESS3,16,ERRMESS0)
		RETURN ''
	ENDIF
	lcWholeTable = STREXTRACT(m.lcWholeDoc,"<w:tbl>","</w:tbl>",m.lnTable)
	lnCurRow = m.lnStartRows
	lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr","</w:tr>",m.lnCurRow)
	DO WHILE !EMPTY(m.lcWholeRow)
		lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr ","</w:tr>",m.lnCurRow)
		IF EMPTY(m.lcWholeRow)
			EXIT
		ENDIF
		SELECT (m.cCur)
		APPEND BLANK
		SCATTER MEMO TO laFieldGat
*!*			FOR lni = 1 TO lnField
*!*				lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
		lni = 1
		lnFieldExtr = 1
		lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
		DO WHILE !EMPTY(m.lcCell) && m.lni <= m.lnField
			lnPar = 1
			lnSpan = 0
			lcSpan = STREXTRACT(m.lcCell,[w:gridSpan w:val="],["])
			IF !EMPTY(m.lcSpan)
				lnSpan = VAL(m.lcSpan) - 1
			ENDIF
			lnFieldExtr = m.lnFieldExtr + m.lnSpan
			lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>])
			lcWholeWal = ""
			DO WHILE !EMPTY(m.lcPar)
				lcPar = STREXTRACT(m.lcPar,[>])
				lnPar = m.lnPar + 1
				
				lnTextPiece = 1
				lcVal = ""
				lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>]) 
				DO WHILE !EMPTY(m.lcTextPiece)
					lnTextPiece = m.lnTextPiece + 1
					IF INLIST(LEFT(m.lcTextPiece,1),' ','>')
						lcVal = m.lcVal + STREXTRACT(m.lcTextPiece,'>')
					ENDIF
					lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>],m.lnTextPiece) 
				ENDDO
				lcWholeWal = m.lcWholeWal + IIF(EMPTY(m.lcWholeWal),"",CHR(13)+CHR(10)) + m.lcVal
				lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>],m.lnPar)
			ENDDO
			IF EMPTY(m.lcWholeWal)
				lni = m.lni + 1
				lnFieldExtr = m.lnFieldExtr + 1
				lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
				LOOP
			ENDIF
			IF m.lnFieldExtr > m.lnField
				EXIT
			ENDIF
*!*				IF laField[m.lni,2] $ "CVM"
*!*					laFieldGat[laField[m.lni,3]] = htmspec(m.lcWholeWal)
*!*				ELSE
*!*					IF laField[m.lni,2] $ "NFBYI"
*!*						laFieldGat[laField[m.lni,3]] = VAL(m.lcWholeWal)
*!*					ELSE
*!*						IF laField[m.lni,2] $ "D"
*!*							laFieldGat[laField[m.lni,3]] = CTOD(m.lcWholeWal)
*!*						ELSE
*!*							IF laField[m.lni,2] $ "T"
*!*								laFieldGat[laField[m.lni,3]] = CTOT(m.lcWholeWal)
*!*							ELSE
*!*								IF laField[m.lni,2] $ "L"
*!*									laFieldGat[laField[m.lni,3]] = LOWER(m.lcWholeWal) == m.lcTrue
*!*								ENDIF
*!*							ENDIF
*!*						ENDIF
*!*					ENDIF
*!*				ENDIF
*!*			NEXT
			IF laField[m.lnFieldExtr - m.lnSpan,2] $ "CVM"
				laFieldGat[laField[m.lnFieldExtr - m.lnSpan,3]] = htmspec(m.lcWholeWal)
			ELSE
				IF laField[m.lni,2] $ "NFBYI"
					laFieldGat[laField[m.lnFieldExtr - m.lnSpan,3]] = VAL(m.lcWholeWal)
				ELSE
					IF laField[m.lni,2] $ "D"
						laFieldGat[laField[m.lnFieldExtr - m.lnSpan,3]] = CTOD(m.lcWholeWal)
					ELSE
						IF laField[m.lni,2] $ "T"
							laFieldGat[laField[m.lnFieldExtr - m.lnSpan,3]] = CTOT(m.lcWholeWal)
						ELSE
							IF laField[m.lni,2] $ "L"
								laFieldGat[laField[m.lnFieldExtr - m.lnSpan,3]] = LOWER(m.lcWholeWal) == m.lcTrue
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
			lni = m.lni + 1
			lnFieldExtr = m.lnFieldExtr + 1
			lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
		ENDDO
		SELECT (m.cCur)
		GATHER FROM laFieldGat MEMO
		lnCurRow = m.lnCurRow + 1
	ENDDO
	SET DECIMALS TO &lcSetDec 
RETURN m.cCur

**********************
* Special characters *
**********************
FUNCTION htmspec
	LPARAMETERS cStr
	LOCAL lni,lcStrF,lcChar,lnChar
	lcStrF = m.cStr
	IF AT('&gt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&gt;','>')
	ENDIF
	IF AT('&lt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&lt;','<')
	ENDIF
	IF AT('&quot;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&quot;','"')
	ENDIF
	IF AT("&apos;",m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&apos;',"'")
	ENDIF
	IF AT([&#],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#]+STR(m.lnChar,3)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT([&#x],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#x]+RIGHT(TRANSFORM(m.lnChar,"@0"),2)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT('&amp;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&amp;',CHR(38))
	ENDIF

    * suggested by Koen Piller
	lcStrF = STRCONV(m.lcStrF,11)
	RETURN m.lcStrF
ENDFUNC

*****************
* Cleanup
******************
FUNCTION cleanup
	LPARAMETERS lcDir
	LOCAL lcZip,lcSetSaf
	lcZip = FORCEEXT(m.lcDir,'zip')
	lcSetSaf = SET("Safety")
	SET SAFETY OFF
	TRY 
		ERASE (ADDBS(m.lcDir)+'*.*')
		RD (m.lcDir)
	CATCH TO m.loErr
	ENDTRY

	ERASE (m.lcZip)
	SET SAFETY &lcSetSaf
RETURN .T.
